#include<stdio.h>
#include<string.h>
#include<malloc.h>

class String{
	int size;	
	char *buff;	
public:
	String() {buff=0;size=0;}
	String(const char *t) {size=strlen(t); buff=strdup(t);}
	String(const String& obj) {size=obj.size; buff=strdup(obj.buff);}
	~String() {free(buff);}
	char *data() {return buff;}
	friend String operator+(String &s1,String &s2) {
		String res;
		res.size=s1.size+s2.size;
		res.buff=(char*)malloc(res.size+1);
		strcpy(res.buff,s1.buff);
		strcat(res.buff,s2.buff);
		return res;
	}
};




int main()
{
	String s1("one!");
	String s2("two!");
	String s3("tree!");
	String s=s1+s2+s3;
	printf("%s\n",s.data());
	return 0;
}

